How to check the version of Python modules

Each Answer to this Q is separated by one/two green lines.

I just installed the Python modules: construct and statlib with setuptools like this:

# Install setuptools to be able to download the following
sudo apt-get install python-setuptools

# Install statlib for lightweight statistical tools
sudo easy_install statlib

# Install construct for packing/unpacking binary data
sudo easy_install construct

I want to be able to (programmatically) check their versions. Is there an equivalent to python --version I can run from the command line?

My Python version is 2.7.3.

I suggest using pip in place of easy_install. With pip, you can list all installed packages and their versions with

pip freeze

In most Linux systems, you can pipe this to grep (or findstr on Windows) to find the row for the particular package you’re interested in:

Linux:

pip freeze | grep lxml

lxml==2.3

Windows:

pip freeze | findstr lxml

lxml==2.3

For an individual module, you can try the __version__ attribute. However, there are modules without it:

python -c "import requests; print(requests.__version__)"
2.14.2

python -c "import lxml; print(lxml.__version__)"

Traceback (most recent call last):
File “<string>”, line 1, in <module>
AttributeError: ‘module’ object has no attribute ‘version

Lastly, as the commands in your question are prefixed with sudo, it appears you’re installing to the global python environment. I strongly advise to take look into Python virtual environment managers, for example virtualenvwrapper.

You can try

>>> import statlib
>>> print statlib.__version__

>>> import construct
>>> print contruct.__version__

This is the approach recommended by PEP 396. But that PEP was never accepted and has been deferred. In fact, there appears to be increasing support amongst Python core developers to recommend not including a __version__ attribute, e.g. in Remove importlib_metadata.version..

Python >= 3.8:

If you’re on Python >= 3.8, you can use a module from the built-in library for that. To check a package’s version (in this example construct) run:

>>> from importlib.metadata import version
>>> version('construct')
'4.3.1'

Python < 3.8:

Use pkg_resources module distributed with setuptools library. Note that the string that you pass to get_distribution method should correspond to the PyPI entry.

>>> import pkg_resources
>>> pkg_resources.get_distribution('construct').version
'2.5.2'

Side notes:

  1. Note that the string that you pass to the get_distribution method should be the package name as registered in PyPI, not the module name that you are trying to import. Unfortunately, these aren’t always the same (e.g. you do pip install memcached, but import memcache).

  2. If you want to apply this solution from the command line you can do something like:

python -c \
  "import pkg_resources; print(pkg_resources.get_distribution('construct').version)"

Use pip show to find the version!

# In order to get the package version, execute the below command
pip show YOUR_PACKAGE_NAME | grep Version

You can use pip show YOUR_PACKAGE_NAME – which gives you all details of package. This also works in Windows.

grep Version is used in Linux to filter out the version and show it.

The better way to do that is:


For the details of a specific package

pip show <package_name>

It details out the package_name, version, author, location, etc.


$ pip show numpy

Name: numpy
Version: 1.13.3
Summary: NumPy: array processing for numbers, strings, records, and objects.
Home-page: http://www.numpy.org
Author: NumPy Developers
Author-email: [email protected]
License: BSD
Location: c:\users\prowinjvm\appdata\local\programs\python\python36\lib\site-packages
Requires:

For more details: >>> pip help


pip should be updated to do this.

pip install --upgrade pip

On Windows the recommended command is:

python -m pip install --upgrade pip

In Python 3 with brackets around print:

>>> import celery
>>> print(celery.__version__)
3.1.14

module.__version__ is a good first thing to try, but it doesn’t always work.

If you don’t want to shell out, and you’re using pip 8 or 9, you can still use pip.get_installed_distributions() to get versions from within Python:

The solution here works in pip 8 and 9, but in pip 10 the function has been moved from pip.get_installed_distributions to pip._internal.utils.misc.get_installed_distributions to explicitly indicate that it’s not for external use. It’s not a good idea to rely on it if you’re using pip 10+.

import pip

pip.get_installed_distributions()  # -> [distribute 0.6.16 (...), ...]

[
    pkg.key + ': ' + pkg.version
    for pkg in pip.get_installed_distributions()
    if pkg.key in ['setuptools', 'statlib', 'construct']
] # -> nicely filtered list of ['setuptools: 3.3', ...]

The previous answers did not solve my problem, but this code did:

import sys 
for name, module in sorted(sys.modules.items()): 
  if hasattr(module, '__version__'): 
    print name, module.__version__ 

Use dir() to find out if the module has a __version__ attribute at all.

>>> import selenium
>>> dir(selenium)
['__builtins__', '__doc__', '__file__', '__name__',
 '__package__', '__path__', '__version__']
>>> selenium.__version__
'3.141.0'
>>> selenium.__path__
['/venv/local/lib/python2.7/site-packages/selenium']

You can try this:

pip list

This will output all the packages with their versions.

Output

In the Python 3.8 version there is a new metadata module in the importlib package, which can do that as well.

Here is an example from documentation:

>>> from importlib.metadata import version
>>> version('requests')
'2.22.0'

If the methods in previous answers do not work, it is worth trying the following in Python:

import modulename

modulename.version
modulename.version_info

See Get the Python Tornado version

Note, the .version worked for me on a few others, besides Tornado as well.

First add executables python and pip to your environment variables. So that you can execute your commands from command prompt. Then simply give Python command.

Then import the package:

import scrapy

Then print the version name

print(scrapy.__version__)

This will definitely work.

Assuming we are using Jupyter Notebook (if using Terminal, drop the exclamation marks):

  1. if the package (e.g., xgboost) was installed with pip:

    !pip show xgboost
    !pip freeze | grep xgboost
    !pip list | grep xgboost
    
  2. if the package (e.g. caffe) was installed with Conda:

    !conda list caffe
    

Some modules don’t have __version__ attribute, so the easiest way is check in the terminal: pip list

I suggest opening a Python shell in the terminal (in the Python version you are interested), importing the library, and getting its __version__ attribute.

>>> import statlib
>>> statlib.__version__

>>> import construct
>>> contruct.__version__

Note 1: We must regard the Python version. If we have installed different versions of Python, we have to open the terminal in the Python version we are interested in. For example, opening the terminal with Python 3.8 can (surely will) give a different version of a library than opening with Python 3.5 or Python 2.7.

Note 2: We avoid using the print function, because its behavior depends on Python 2 or Python 3. We do not need it, and the terminal will show the value of the expression.

This answer is for Windows users. As suggested in all other answers, you can use the statements as:

import [type the module name]
print(module.__version__) # module + '.' + double underscore + version + double underscore

But, there are some modules which don’t print their version even after using the method above. So, you can simply do:

  1. Open the command prompt.
  2. Navigate to the file address/directory by using cd (file address) where you’ve kept your Python and all supporting modules installed. If you have only one Python interpreter on your system, the PyPI packages are normally visible in the directory/folder: Python ? Lib ? site-packages.
  3. use the command “pip install [module name]” and hit Enter.
  4. This will show you a message as “Requirement already satisfied: file address\folder name (with version)“.
  5. See the screenshot below for example: I had to know the version of a pre-installed module named “Selenium-Screenshot”. It correctly showed as 1.5.0:

Command prompt screenshot

In summary:

conda list

(It will provide all the libraries along with version details.)

And:

pip show tensorflow

(It gives complete library details.)

(See also How do I get the version of an installed module in Python programmatically?)

I found it quite unreliable to use the various tools available (including the best one pkg_resources mentioned by Jakub Kukul’ answer), as most of them do not cover all cases. For example

  • built-in modules
  • modules not installed but just added to the python path (by your IDE for example)
  • two versions of the same module available (one in python path superseding the one installed)

Since we needed a reliable way to get the version of any package, module or submodule, I ended up writing getversion. It is quite simple to use:

from getversion import get_module_version
import foo
version, details = get_module_version(foo)

See the documentation for details.

This works in Jupyter Notebook on Windows, too! As long as Jupyter is launched from a Bash-compliant command line such as Git Bash (Mingw-w64), the solutions given in many of the answers can be used in Jupyter Notebook on Windows systems with one tiny tweak.

I’m running Windows 10 Pro with Python installed via Anaconda, and the following code works when I launch Jupyter via Git Bash (but does not when I launch from the Anaconda prompt).

The tweak: Add an exclamation mark (!) in front of pip to make it !pip.

>>>!pip show lxml | grep Version
Version: 4.1.0

>>>!pip freeze | grep lxml
lxml==4.1.0

>>>!pip list | grep lxml
lxml                               4.1.0

>>>!pip show lxml
Name: lxml
Version: 4.1.0
Summary: Powerful and Pythonic XML processing library combining libxml2/libxslt with the ElementTree API.
Home-page: http://lxml.de/
Author: lxml dev team
Author-email: [email protected]
License: BSD
Location: c:\users\karls\anaconda2\lib\site-packages
Requires:
Required-by: jupyter-contrib-nbextensions

A Python program to list all packages (you can copy it to file requirements.txt):

from pip._internal.utils.misc import get_installed_distributions
print_log = ''
for module in sorted(get_installed_distributions(), key=lambda x: x.key):
    print_log +=  module.key + '~=' + module.version  + '\n'
print(print_log)

The output would look like:

asn1crypto~=0.24.0
attrs~=18.2.0
automat~=0.7.0
beautifulsoup4~=4.7.1
botocore~=1.12.98

After scouring the Internet, trying to figure out how to ensure the version of a module I’m running (apparently python_is_horrible.__version__ isn’t a thing in Python 2?) across operating systems and Python versions… literally none of these answers worked for my scenario…

Then I thought about it a minute and realized the basics… after ~30 minutes of fails…

assumes the module is already installed and can be imported


Python 3.7

>>> import sys,sqlite3
>>> sys.modules.get("sqlite3").version
'2.6.0'
>>> ".".join(str(x) for x in sys.version_info[:3])
'3.7.2'

Python 2.7

>>> import sys,sqlite3
>>> sys.modules.get("sqlite3").version
'2.6.0'
>>> ".".join(str(x) for x in sys.version_info[:3])
'2.7.11'

Literally that’s it…

To get a list of non-standard (pip) modules imported in the current module:

[{pkg.key : pkg.version} for pkg in pip.get_installed_distributions() 
   if pkg.key in set(sys.modules) & set(globals())]

Result:

>>> import sys, pip, nltk, bs4
>>> [{pkg.key : pkg.version} for pkg in pip.get_installed_distributions() if pkg.key in set(sys.modules) & set(globals())]
[{'pip': '9.0.1'}, {'nltk': '3.2.1'}, {'bs4': '0.0.1'}]

Note:

This code was put together from solutions both on this page and from How to list imported modules?

For situations where field __version__ is not defined:

try:
    from importlib import metadata
except ImportError:
    import importlib_metadata as metadata # python<=3.7

metadata.version("package")

Alternatively, and like it was already mentioned:

import pkg_resources
pkg_resources.get_distribution('package').version

Here’s a small Bash program to get the version of any package in your Python environment. Just copy this to your /usr/bin and provide it with executable permissions:

#!/bin/bash
packageName=$1

python -c "import ${packageName} as package; print(package.__version__)"

Then you can just run it in the terminal, assuming you named the script py-check-version:

py-check-version whatever_package

And in case your production system is hardened beyond comprehension so it has neither pip nor conda, here is a Bash replacement for pip freeze:

ls /usr/local/lib/python3.8/dist-packages | grep info | awk -F "-" '{print $1"=="$2}' | sed 's/.dist//g'

(make sure you update your dist-packages folder to your current python version and ignore inconsistent names, e.g., underscores vs. dashes).

Sample printout:

Flask==1.1.2
Flask_Caching==1.10.1
gunicorn==20.1.0
[..]

Building on Jakub Kukul’s answer I found a more reliable way to solve this problem.

The main problem of that approach is that requires the packages to be installed “conventionally” (and that does not include using pip install --user), or be in the system PATH at Python initialisation.

To get around that you can use pkg_resources.find_distributions(path_to_search). This basically searches for distributions that would be importable if path_to_search was in the system PATH.

We can iterate through this generator like this:

avail_modules = {}
distros = pkg_resources.find_distributions(path_to_search)
for d in distros:
    avail_modules[d.key] = d.version

This will return a dictionary having modules as keys and their version as value. This approach can be extended to a lot more than version number.

Thanks to Jakub Kukul for pointing in the right direction.

I myself work in a heavily restricted server environment and unfortunately none of the solutions here are working for me. There may be no global solution that fits all, but I figured out a swift workaround by reading the terminal output of pip freeze within my script and storing the modules labels and versions in a dictionary.

import os
os.system('pip freeze > tmpoutput')
with open('tmpoutput', 'r') as f:
    modules_version = f.read()
  
module_dict = {item.split("==")[0]:item.split("==")[-1] for item in modules_versions.split("\n")}

Retrieve your module’s versions through passing the module label key, e.g.:

>>  module_dict["seaborn"]
'0.9.0'

Go to terminal like pycharm-terminal

Now write py or python
and hit Enter.

Now you are inside python in the terminal you can try this way:

# import <name_of_the_library>

import kivy

# So if the library has __version__ magic method, so this way will help you

kivy.__version__  # then hit Enter to see the version

# Output >> '2.1.0'

but if the above way not working for you can try this way to know information include the version of the library

 pip show module <HERE PUT THE NAME OF THE LIBRARY>

Example:

pip show module pyperclip

Output:
       Name: pyperclip
       Version: 1.8.2
       Summary: A cross-platform clipboard module for Python. (Only handles plain text for now.)
       Home-page: https://github.com/asweigart/pyperclip
       Author: Al Sweigart
       Author-email: [email protected]
       License: BSD
       Location: c:\c\kivymd\virt\lib\site-packages
       Requires:
       Required-by:

There is another way that could help you to show all the libraries and versions of them inside the project:

pip freeze
# I used the above command in a terminal inside my project this is the output
       certifi==2021.10.8
       charset-normalizer==2.0.12
       docutils==0.18.1
       idna==3.3
       Kivy==2.1.0
       kivy-deps.angle==0.3.2
       kivy-deps.glew==0.3.1
       kivy-deps.sdl2==0.4.5
       Kivy-Garden==0.1.5
       kivymd @ file:///C:/c/kivymd/KivyMD
       Pillow==9.1.0
       Pygments==2.12.0
       pyperclip==1.8.2
       pypiwin32==223
       pywin32==303
       requests==2.27.1
       urllib3==1.26.9

and sure you can try using the below command to show all libraries and their versions

pip list

Hope to Help anyone,
Greetings

You can first install some package like this and then check its version:

pip install package
import package
print(package.__version__)

It should give you the package version.


The answers/resolutions are collected from stackoverflow, are licensed under cc by-sa 2.5 , cc by-sa 3.0 and cc by-sa 4.0 .